zoukankan      html  css  js  c++  java
  • USACO 2009 FEB Fair Shuttle 庙会班车 贪心

    题目

    题目描述

    Although Farmer John has no problems walking around the fair to collect prizes or see the shows, his cows are not in such good shape; a full day of walking around the fair leaves them exhausted. To help them enjoy the fair, FJ has arranged for a shuttle truck to take the cows from place to place in the fairgrounds.

    FJ couldn't afford a really great shuttle, so the shuttle he rented traverses its route only once (!) and makes N (1 <= N <= 20,000) stops (conveniently numbered 1..N) along its path. A total of K (1 <= K <= 50,000) groups of cows conveniently numbered 1..K wish to use the shuttle, each of the M_i (1 <= M_i <= N) cows in group i wanting to ride from one stop S_i (1 <= S_i < E_i) to another stop E_i (S_i < E_i <= N) farther along the route.

    The shuttle might not be able to pick up an entire group of cows (since it has limited capacity) but can pick up partial groups as appropriate.

    Given the capacity C (1 <= C <= 100) of the shuttle truck and the descriptions of the groups of cows that want to visit various sites at the fair, determine the maximum number of cows that can ride the shuttle during the fair.

    逛逛集市,兑兑奖品,看看节目对农夫约翰来说不算什么,可是他的奶牛们非常缺乏锻炼——如果要逛完一整天的集市,他们一定会筋疲力尽的。所以为了让奶牛们也能愉快地逛集市,约翰准备让奶牛们在集市上以车代步。但是,约翰木有钱,他租来的班车只能在集市上沿直线跑一次,而且只能停靠N(1 ≤N≤20000)个地点(所有地点都以1到N之间的一个数字来表示)。现在奶牛们分成K(1≤K≤50000)个小组,第i 组有Mi(1 ≤Mi≤N)头奶牛,他们希望从Si跑到Ti(1 ≤Si<Ti≤N)。

    由于班车容量有限,可能载不下所有想乘车的奶牛们,此时也允许小里的一部分奶牛分开乘坐班车。约翰经过调查得知班车的容量是C(1≤C≤100),请你帮助约翰计划一个尽可能满足更多奶牛愿望的方案。

    输入输出格式

    输入格式:

    【输入】

    第一行:包括三个整数:K,N和C,彼此用空格隔开。

    第二行到K+1行:在第i+1行,将会告诉你第i组奶牛的信息:Si,Ei和Mi,彼

    此用空格隔开。

    输出格式:

    【输出】

    第一行:可以坐班车的奶牛的最大头数。

    输入输出样例

    输入样例#1: 复制
    8 15 3
    1 5 2
    13 14 1
    5 8 3
    8 14 2
    14 15 1
    9 12 1
    12 15 2
    4 6 1
    
    输出样例#1: 复制
    10
    

    说明

    【样例说明】

    班车可以把2头奶牛从1送到5,3头奶牛从5送到8,2头奶牛从8送到14,1头

    奶牛从9送到12,1头奶牛从13送到14,1头奶牛从14送到15。

    分析

    这题用了一个非常有趣的贪心。首先要做的是所有小组按照他们的终点站排序,然后在这个小组所要经过的区间里找,如果之前经过过的小组已经使得在这条路上的某一个站点的剩余座位是为0,就说明这个小组没有人能上车。如果大于0,那么就可以上这么多人。然后在这个区间里减掉这个最少人数。

    注意,如果不加一点优化会TLE。我们的思路导致主要的时间消耗是在扫每个队的经过区间来计算最小剩余座位。那么很容易想到如果已经扫到了0,直接退出循环。另外,如果为0,就不必在减去了,这样可以剩下大把时间。

    程序

    #include <bits/stdc++.h>
    using namespace std;
    const int MAXK = 50000 + 1;
    const int MAXN = 20000 + 1;
    struct group
    {
        int s, e, m;
    }g[MAXK];
    int k, n, c, st[MAXN], Min_Seats, ans;
    bool comp(group x, group y)
    {
        return x.e < y.e;
    }
    int main()
    {
        cin >> k >> n >> c;
        for (int i = 1; i <= k; i++)
            cin >> g[i].s >> g[i].e >> g[i].m;
        for (int i = 1; i <= n; i++)
            st[i] = c;
        sort(g+1, g+(k+1), comp);
        for (int i = 1; i <= k; i++)
        {
            Min_Seats = g[i].m;
            for (int j = g[i].s; j < g[i].e; j++)
            {
                Min_Seats = min(Min_Seats, st[j]);
                if (!Min_Seats)
                    break;
            }
            if (Min_Seats)
            {
                ans += Min_Seats;
                for (int j = g[i].s; j < g[i].e; j++)
                    st[j] -= Min_Seats;
            }
        }
        cout << ans << endl;
        return 0;
    }
  • 相关阅读:
    分享点干货(此this非彼this)this的详细解读
    程序员需要掌握的排序算法之希尔排序(最小增量排序)
    JAVA基础学习笔记
    简单的时间日期格式化(未封装成控件)
    面试造航母,工作拧螺丝
    浅谈jquery插件开发模式
    Relative与Absolute组合使用
    表单
    个人介绍
    用计数法解决数组排序问题
  • 原文地址:https://www.cnblogs.com/OIerPrime/p/8504482.html
Copyright © 2011-2022 走看看